package com.huimv.eartag2.config;

import com.huimv.eartag2.common.mq.Const;
import com.huimv.eartag2.service.RabbitMQService;
import org.springframework.amqp.core.AmqpAdmin;
import org.springframework.amqp.core.Binding;  
import org.springframework.amqp.core.BindingBuilder;  
import org.springframework.amqp.core.DirectExchange;  
import org.springframework.amqp.core.Queue;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.ApplicationArguments;
import org.springframework.boot.ApplicationRunner;  
import org.springframework.stereotype.Component;
import sun.rmi.runtime.Log;

import java.util.List;  
import java.util.Map;  
  
@Component  
public class RabbitMQInitializer implements ApplicationRunner {

    @Autowired
    private RabbitMQService rabbitMQService;

    @Value("${rabbitmq.queues}")
    private Integer queues;

    @Override  
    public void run(ApplicationArguments args)   {
        // 声明交换机
        // 创建交换机
        rabbitMQService.createExchange(Const.EXCHANGE_ASK_EARTAG);
        //
        for (Integer integer = 0; integer < queues; integer++) {
            // 声明队列
            rabbitMQService.createQueue(Const.QUEUE_ASK_EARTAG+integer);
            // 创建绑定
            rabbitMQService.createBinding(Const.QUEUE_ASK_EARTAG+integer, Const.EXCHANGE_ASK_EARTAG,Const.ROUTING_KEY_ASK_EARTAG+integer  );
        }
    }



}