package com.huimv.eartag2.config;

import org.springframework.amqp.core.Binding;
import org.springframework.amqp.core.BindingBuilder;
import org.springframework.amqp.core.DirectExchange;
import org.springframework.amqp.core.Queue;
import org.springframework.amqp.rabbit.core.RabbitAdmin;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

@Configuration
public class RabbitMqConfig {
    
    @Bean
    public Queue dynamicQueue(final RabbitAdmin rabbitAdmin) {
        return new Queue(queueName(), true);
    }
    
    @Bean
    public DirectExchange dynamicExchange(final RabbitAdmin rabbitAdmin) {
        return new DirectExchange(exchangeName(), true, false);
    }
    
    @Bean
    public Binding binding(Queue dynamicQueue, DirectExchange dynamicExchange) {
        return BindingBuilder.bind(dynamicQueue).to(dynamicExchange).with(routingKey());
    }
    
    private String queueName() {
        // 动态生成的队列名称
        return "dynamicQueue";
    }
    
    private String exchangeName() {
        // 动态生成的交换机名称
        return "dynamicExchange";
    }
    
    private String routingKey() {
        // 路由键
        return "routingKey";
    }
}