package com.huimv.eartag2.service;

import org.springframework.amqp.core.AmqpAdmin;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.amqp.core.Queue;
import org.springframework.amqp.core.DirectExchange;
import org.springframework.amqp.core.Exchange;
import org.springframework.amqp.core.Binding;
import org.springframework.amqp.core.BindingBuilder;

@Service  
public class RabbitMQService {  
  
    private final AmqpAdmin amqpAdmin;  
  
    @Autowired  
    public RabbitMQService(AmqpAdmin amqpAdmin) {  
        this.amqpAdmin = amqpAdmin;  
    }


    public void createQueue(String queueName) {
        Queue queue = new Queue(queueName);
        amqpAdmin.declareQueue(queue);
    }

    public void createExchange(String exchangeName) {
        Exchange exchange = new DirectExchange(exchangeName);
        amqpAdmin.declareExchange(exchange);
    }
    public void createBinding(String queueName, String exchangeName, String routingKey) {

//        amqpAdmin.declareBinding(BindingBuilder.bind(new Queue(queueName, true)).to(new DirectExchange(exchangeName, true, false)).with(routingKey));
        Queue queue = new Queue(queueName);
        Binding binding = BindingBuilder.bind(queue).to(new DirectExchange(exchangeName)).with(routingKey);
        amqpAdmin.declareBinding(binding);
    }
}